// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "GSV86CAN.h"
//#define TEST_LOAD6AX
//#define TEST_READ6AX
//#define TEST_AOUT
//#define SETINRANGE
//#define TESTE_DIVERSES
#define TESTE_DIGI_FILTER
#define DIGIFILT_SIMUL_RES_FPATH "C:\\test\\gsv6freqResponse.txt"

#define MYBUFFERSIZE	300
#define CANID_COMMAND 0x100
#define CANID_ANSWER 0x101
#define CANBAUD 500000

using namespace std;

int main(int argc, char* argv[])
{
	int ret,ret2, CmdID, respID, valCnt,j,i;
	int Dev,chanNo=0;
	unsigned long ErrCod,rec;
	char ErrTxt[256], id[8];
	unsigned char serTxt[10], AoutEnum, aoutmode;
	char Fname[256];
	char Taste=0;
	double* Warr;
	int* ErrArr;
	double Wert[8];
	int valErr[MYBUFFERSIZE];
	unsigned long dllVer,serno, FWver;
#ifdef TEST_LOAD6AX
	OPENFILENAMEA ofn;       // common dialog box structure
#endif
	//char szFile[260];       // buffer for file name
	//HWND hwnd;              // owner window
	double ofs[3], matrix[36], max[6], norm, sens, zvals[6];

	ret= GSV86CANDllVersion(&dllVer);
	cout<<endl<<"DLL version: "<<dllVer<<endl<<flush;
	Dev=1;
	ret= GSV86CANactivateExtended(Dev,CANADAPTERTYPE_PCAN,CANBAUD,MYBUFFERSIZE,&chanNo,CANID_COMMAND,CANID_ANSWER,AE_FLAG_TYPEGSV6); //AE_FLAG_TYPEGSV6|AE_FLAG_LOGCAN|AE_FLAG_SHOWCAN);
	if(ret==GSV_ERROR)
	{
		Dev=2;
		ret= GSV86CANactivateExtended(Dev,CANADAPTERTYPE_PCAN,CANBAUD,MYBUFFERSIZE,&chanNo,CANID_COMMAND,CANID_ANSWER,AE_FLAG_TYPEGSV6); //AE_FLAG_TYPEGSV6|AE_FLAG_LOGCAN|AE_FLAG_SHOWCAN);
		if(ret==GSV_ERROR)
		{
			ret= GSV86CANgetLastErrorText(Dev, ErrTxt,&ErrCod);
			cout<<endl<<"Open device failed"<<endl<<ErrTxt<<endl<<"Code="<<ErrCod<<flush;
			cout<<endl<<"any key..."<<flush;
			_getch(); fflush(stdout); fflush(stdin);
			ret= GSV86CANrelease(0);
			return 0;
		}
		
	}
	else
		cout<<"Result: "<<ret<<endl<<flush;
#ifdef TESTE_DIVERSES
	ret= GSV86CANgetSerialNo(Dev,&serno);
	cout<<endl<<"SerNo: "<<serno<<flush;
	ret= GSV86CANgetFirmwareVersion(Dev,&FWver);
	cout<<endl<<"FWver: "<<(FWver/65536)<<"."<<(FWver&0xFFFF)<<flush;
	ret = GSV86CANreadFTSensorSerNo(Dev, 0, serTxt);
#endif
#ifdef TESTE_DIGI_FILTER
	unsigned long DonOff;
	ret= GSV86CANgetDfilterOnOff(Dev, &DonOff);
	cout<<endl<<"GSV86CANgetDfilterOnOff: "<<ret<<"D filter: "<<DonOff<<flush;
	double cutoff[2];
	int dFtyp;
	/***********************************************************************************************************************
	get the activated filter setup of the channel
	------------------------------------------------------------------------------------------------------------------------
	\in   DevNo					device handle number
	\in   Chan					input channel number, 1..6 (GSV-6), 1..8 (GSV-8)
	\in   TypeIn				input filter characteristic:
									0x00 = FILT_TYPE_IIR
									0x80 = FILT_TYPE_FIR
	\out  TypeOut				filter type:
									0 = low pass
									1 = high pass
									2 = band pass
									3 = band stop
	\out  CouOff				pointer to cut frequency (min. arraysize = 2)
	\return						simple errorcode: GSV_OK, on success or GSV_ERROR on failure
									If GSV_ERROR is returned, then a more detailed error information can be retrieved with
									GSV86CANgetLastProtocolError.
	***********************************************************************************************************************/
	ret= GSV86CANgetDfilterInfo(Dev,2,0,&dFtyp,&cutoff[0]);
	
	/***********************************************************************************************************************
	Calculate and set Digital Filter Parameters
	------------------------------------------------------------------------------------------------------------------------
	\in   DevNo					device handle number
	\in   Chan					input channel number, 1..6 (GSV-6), 1..8 (GSV-8)
								-1 = do not send data to the connected GSV
	\in   Class					filter class:   0 = IIR
	\in   Charac				filter characteristic:
									0 = Low pass
									1 = high pass
									2 = band pass
									3 = band stop
	\in   Type					filter type:
									1 = Bessel
									2 = Butterworth
	\in   Order					filter length:  4 = IIR
	\in   CutOff				cut off frequency low
	\in   CutOffHi				cut off frequency high
	\return						simple errorcode: GSV_OK, on success or GSV_ERROR on failure
									If GSV_ERROR is returned, then a more detailed error information can be retrieved with
									GSV86CANgetLastProtocolError. */
	ret=GSV86CANcalcSetDfilterParams(Dev,-1,0,1,2,4,100,110);
	cout<<endl<<"GSV86CANcalcSetDfilterParams: "<<ret<<flush;
	
	/***********************************************************************************************************************
	Get digital filter coefficients 
	------------------------------------------------------------------------------------------------------------------------
	\in   DevNo				device handle number
	\in   Chan				input channel number, 1..8
							or -1: get from DLL only (was set by previous call to GSV86CANcalcSetDfilterParams with Chan=-1
	\in   Type				type:  0x00 = FILT_TYPE_IIR: Get Filter Coefficients for the IIR filter
	\out Coeff				pointer to double array of min. size =5
								IIR filter: the first 5 items contain the a coefficients a0..a4, a0 at index 0.
	\out CoeffB				pointer to double array of min. size =4.
								IIR filter: the 4 items contain the b coefficients b0..b3, with b0 at index 0.
	\return					simple errorcode: GSV_OK, on success or GSV_ERROR on failure
								If GSV_ERROR is returned, then a more detailed error information can be retrieved with
								GSV86CANgetLastProtocolError.*/
	double coeffA[5], coeffB[4];
	ret=GSV86CANgetDfilterCoeff(Dev,-1,0,coeffA,coeffB);
	cout<<endl<<"GSV86CANcalcSetDfilterParams: "<<ret<<flush;
	/*************************************************************************************
	Digital Filter time-domain simulation
--------------------------------------------------------------------------------------
 \in    DevNo	device handle number
 	Analyze_Ftyp: one of
 		SIMUL_DFILT_FREQ_RESPONSE=1 get Frequency response
 		SIMUL_DFILT_STEP_RESPONSE=2 get step response
 	StartVal: First frequency if Analyze_Ftyp=SIMUL_DFILT_FREQ_RESPONSE
 		Start value (before step) if Analyze_Ftyp=SIMUL_DFILT_STEP_RESPONSE (standard step: =0)
 	EndVal: Last frequency if Analyze_Ftyp=SIMUL_DFILT_FREQ_RESPONSE
 		Step value (after step) if Analyze_Ftyp=SIMUL_DFILT_STEP_RESPONSE (standard step: =1)
 	Fa:	Sampling frequency = Data rate
 	Points: Number of simulated points (frequencies or samples, respective)
 	Filepath: Full path to file, where results are written to. File should not exist before;
 		otherwise, it will be overwritten. Path must exist already (won't be created)
 \return Simple errorcode: GSV_OK,if successful or GSV_ERROR if function failed
 If GSV_ERROR, more detailed error information ca be retrieved with GSV86getLastProtocollError.
 Additional possible error codes:
 #define DF_ERR_NOT_INIT 0x30000201 GSV86calcSetDfilterParams not called before
 #define DF_ERR_OPT_WRONG 0x30000202 wrong parameters
 #define DF_ERR_NO_CONVERGENCE 0x30000203 coefficient calculation failed to converge
 #define DF_ERR_COEFF_SUM_TOOBIG 0x30000208 coefficients are too big
--------------------------------------------------------------------------------------
 \remark: GSV86calcSetDfilterParams must be called before.
 	There, Chan can be set to -1 for simulation only (no device access).
--------------------------------------------------------------------------------------
 Device access: if Fa<1 only
---------------------------------------------------------------------------------------
 \revision date: 26.09.2016 13:17
 **************************************************************************************/
	ret=GSV86CANsimulateDfilter(Dev,1,0,100,200,600,DIGIFILT_SIMUL_RES_FPATH);
#endif
#ifdef TEST_LOAD6AX
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = NULL; //(AfxGetMainWnd())->GetSafeHwnd( ); //hwnd;
	ofn.lpstrFile = (LPSTR) Fname;
	// Set lpstrFile[0] to '\0' so that GetOpenFileName does not 
	// use the contents of szFile to initialize itself.
	ofn.lpstrFile[0] = '\0';
	ofn.nMaxFile = sizeof(Fname);
	ofn.lpstrFilter = (LPSTR)"Calibration config\0*.dat\0All\0*.*\0\0";
	ofn.nFilterIndex = 1;
	ofn.lpstrFileTitle = NULL;
	ofn.nMaxFileTitle = 0;
	ofn.lpstrInitialDir = NULL;
	ofn.lpstrTitle = (LPSTR)"Load Configuration";
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

	if (GetOpenFileNameA(&ofn) == TRUE)
	{
		ret = GSV86CANwriteFTSensorCalFromFile(1, 0, Fname);
		if (ret)
		{
			ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
			cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
		}
		ret = GSV86CANsetID(1, "USC1");
		if (ret)
		{
			ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
			cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
		}
		ret = GSV86CANstoreFTSensorCal(1, 0);
		if (ret)
		{
			ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
			cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
		}
		ret = GSV86CANsetFTSensorCalArrNo(1, 0);
		if (ret)
		{
			ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
			cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
		}
	}
#endif
#ifdef TEST_READ6AX
	ret = GSV86CANreadFTSensorCalArray(1, 0, serTxt, &norm, &sens, &matrix[0], &ofs[0], &max[0]);
	if (ret)
	{
		ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
		cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
	}
#endif
#ifdef TEST_AOUT
	ret=GSV86CANgetAoutType(1,1,&AoutEnum,&aoutmode);
	if (ret)
	{
		ret = GSV86CANgetLastErrorText(1, ErrTxt, &ErrCod);
		cout << endl << "err: " << endl << ErrTxt << endl << "Code=" << ErrCod << flush;
	}
#endif

	Warr= (double*)malloc(MYBUFFERSIZE*6*sizeof(double));
	ErrArr = (int*) malloc(MYBUFFERSIZE * 6 * sizeof(int));
	ret=GSV86CANstartTX(1);
	while(Taste != 'q')
	{
#ifdef TESTE_DIVERSES
		ret2 = GSV86CANreceived(1, 0, &rec);
#endif
		ret = GSV86CANreadMultiple(1, 0, Warr, MYBUFFERSIZE * 6, &valCnt, ErrArr); // &valErr[0]);
#ifdef TESTE_DIVERSES
		if(ret==GSV_TRUE && rec>0)
#else
		if(ret==GSV_TRUE)
#endif
		{
			for(i=0;i<(valCnt/6);i++)
			{
				for(j=0;j<8;j++)
				{
					Wert[j]= Warr[(i*6)+j];
				}
				printf("Ch1: %.4lf Ch2: %.4lf Ch3: %.4lf Ch4: %.4lf Ch5: %.4lf Ch6: %.4lf\n",Wert[0],Wert[1],Wert[2],Wert[3],Wert[4],Wert[5]);
			}
		}
		else if(ret==GSV_ERROR)
		{
			Sleep(1);
			cout<<endl<<"Error!"<<flush;
		}
		else
			Sleep(1);
		if(_kbhit())
		{
			Taste= _getche();
			switch(Taste)
			{
			case 's':
				cout << "SerNo: " << GSV86CANgetSerialNo(1, &serno) << flush;
				break;
			default:
				break;
			}
		}
	}
	
	ret= GSV86CANrelease(0);
	return 0;
}



